# Copyright 2016 Adrien Vergé
# Inspired from https://github.com/cloudant/packages/tree/44deccd/rpm

Name: bigcouch
Version: 0.4.2b
Release: 1%{?dist}
License: Apache
Group: Applications/Databases
URL: http://cloudant.com
Summary: Distributed version of Apache CouchDB

# Created with:
#   git clone git://github.com/cloudant/bigcouch.git -b bigcouch-0.4.2b
#   tar -czf bigcouch-0.4.2b.tar.gz bigcouch
Source0: bigcouch-%{version}.tar.gz
Source1: http://erlang.org/download/otp_src_R14B01.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}

# For Erlang
BuildRequires: java-1.6.0-openjdk
BuildRequires: ncurses-devel

# For Bigcouch
BuildRequires: git
BuildRequires: js-devel >= 1.8.5
BuildRequires: libicu-devel >= 3.0
BuildRequires: openssl-devel

%{?systemd_requires}
BuildRequires: systemd

%define debug_package %{nil}

%description
BigCouch is a dynamo-style distributed database based on Apache CouchDB.

%prep
%setup -q -n bigcouch
tar -C %{_builddir} -xf %{_sourcedir}/otp_src_R14B01.tar.gz

%build
# Build and install Erlang.
# The version packaged in CentOS 7 is too recent and does not work.
cd %{_builddir}/otp_src_R14B01
./configure --prefix=%{_builddir}/usr/local \
            --enable-kernel-poll \
            --enable-hipe \
            --enable-threads \
            --enable-smp-support
make  # don't use %{?_smp_mflags} here, because -j2 seems to break build
make install

# Build Bigcouch with just-compiled Erlang
cd %{_builddir}/bigcouch
PATH="%{_builddir}/usr/local/bin:$PATH" ./configure -p /opt/%{name}
PATH="%{_builddir}/usr/local/bin:$PATH" make dist %{?_smp_mflags}

%install
mkdir -p %{buildroot}/opt
cp -r %{_builddir}/bigcouch/rel/bigcouch %{buildroot}/opt
mkdir -p %{buildroot}/usr/lib/systemd/system
cat <<EOF >%{buildroot}/usr/lib/systemd/system/bigcouch.service
[Unit]
Description=Bigcouch

[Service]
ExecStart=/opt/bigcouch/bin/bigcouch
User=bigcouch
Group=bigcouch
KillMode=process
Restart=on-failure

[Install]
WantedBy=multi-user.target
EOF

%files
%defattr(-, bigcouch, bigcouch)
/opt/bigcouch
/usr/lib/systemd/system/bigcouch.service

%pre
getent group %{name} >/dev/null || groupadd -r %{name}
getent passwd %{name} >/dev/null || \
  useradd -r -g %{name} -d /home/%{name} -s /sbin/nologin %{name}

%post
%systemd_post bigcouch.service

%preun
%systemd_preun bigcouch.service

%postun
%systemd_postun_with_restart bigcouch.service

%clean
rm -rf %{buildroot}

%changelog
* Tue Aug 30 2016 Adrien Vergé <adrienverge@gmail.com> 0.4.2b-1
- Initial RPM release
